// PAOK BC Hangman
// http://paokara-re.tripod.com/
// Version: April 2008

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <ctime>
#include <cctype>


using namespace std;

void print_start();
void constract_db(vector<string>* words);
void print_win();
void print_end();

int main(){
    //Number of maximum wrong answers
    const int MAX_WRONG = 5;
    int counter,score,correct;
    char guess=0,option='1';
    vector<string> words;
    // Construct Database 
    constract_db(&words);
    // Print starting messages
    print_start();
    cout << "There are " << words.size() << " players in the database.\n";
    cout << "The highest score you can achieve is " << 30*words.size() << endl;
    // Infinite loop unless user quits
    while(1 && guess!=';'){
    if(option=='1'){
    counter=0;
    score=0;
    correct=0;
    // Shuffle the Players
    srand(time(0));
    random_shuffle(words.begin(),words.end());
    // Enter main loop
    while(counter < words.size() && guess!=';'){
    const string THE_WORD = words[counter++];
    int wrong = 0;
    string soFar(THE_WORD.size(),'-');
    string used= "";
    cout << "==============================================";
    cout << "\nPlayer " << counter << "  (" << THE_WORD.size() << " letters)\n";  
    // Get user guesses for current word
    while((wrong < MAX_WRONG) && soFar!=THE_WORD){
                 cout << "\n" << soFar << endl;
                 cout << used;
                 if((MAX_WRONG-wrong)>1)
                          cout << "\nYou have " << (MAX_WRONG-wrong) << " incorrect guesses left.";
                 else
                          cout << "\nYou have " << (MAX_WRONG-wrong) << " incorrect guess left.";

                 
                 cout << "\n\nEnter your guess: ";
                 cin >> guess;
                 guess = toupper(guess);
                 // Check if guess has been guessed before
                 while(used.find(guess) != string::npos){
                          cout <<"\nYou 've already guessed " << guess << endl;
                          cout << "\nEnter your guess: ";
                          cin >> guess;
                          guess = toupper(guess);                          
                          }
                 // Break if user wants to terminate the program
                 if(guess==';')
                 break;
                 used += guess;
                 // Check if guess was correct
                 cout << "\n==============================================\n";
                 if(THE_WORD.find(guess) != string::npos){
                           cout <<"That's right! " << guess << " is in the word.\n";
                           for(int i=0; i < THE_WORD.length(); ++i)
                                   if(THE_WORD[i]==guess)
                                         soFar[i] = guess;
                                   }
                                   else{
                                         cout <<"Sorry. " << guess << " isn't in the word.\n";
                                         ++wrong;
                                   }
                           }            
                 // Check if user lost
                 if(wrong==MAX_WRONG){
                           cout << "\n************************";
                           cout << "\n* You 've been hanged! *";
                           cout << "\n************************\n\n";
                           }
                 // Check if user wants to terminate the program                 
                 else if(guess==';'){
                           cout << "\n***************************";
                           cout << "\n* Game terminated by user *";
                           cout << "\n***************************\n\n";
                           }
                 // Check if user found the word
                 else{
                           correct++;
                           if(wrong==0){
                                     score+=30;
                                     cout << "\n**************************************************************************";
                                     cout << "\n* You 've guessed it without making a single mistake! 30 points for you! *";
                                     cout << "\n**************************************************************************";
                                     }
                           else{
                                     score+=10;
                                     cout << "\n******************************************";
                                     cout << "\n* You 've guessed it! 10 points for you! *";
                                     cout << "\n******************************************";
                           }
                 }
                 if(guess!=';'){
                                cout << "\nThe player was " << THE_WORD << ".\n";
                                cout << "\nYou have " << score <<" points.\n\n";
                 }
                 //If user lost then the game is over
                 if(wrong==MAX_WRONG){break;}
    }
    // Check if user won
    if(correct==words.size()){
                 print_win();     
    }
    // Print ending messages
    cout << "\nYour final score is " << score << " points. You managed to guess " << correct;
    if(correct!=1)
                 cout << " players.\n\n";
    else
                 cout << " player.\n\n";
    }
    // If option is 2
    else{
         print_end();
         system("pause");
         return 0;
    }
    // If user is hanged but has not guessed ';' allow him to restart or quit
    if(guess!=';'){
    cout << "==============================================";   
    cout << "\nPress 1 and hit enter to restart the game\nPress 2 and hit enter to quit\n";
    cin >> option;
    // If user enters something wrong clear stdin and ask again
    while(option != '1' && option != '2'){
                fflush(stdin);
                cout <<"\nWrong input\nPress 1 and hit enter to start the game\nPress 2 and hit enter to quit\n";
                cin >> option;                        
                }
    // Clear stdin so that it doesn't affect the guess
    fflush(stdin);
    }
    }
    print_end();
    system("pause");
    return 0;
    }


void print_start(){
    cout << "|=======================|\n";
    cout << "|PAOK BC Hangman        |\n";
    cout << "|-----------------------|\n";
    cout << "|paokare-re.tripod.com  |\n";
    cout << "|Version: April 2008    |\n";
    cout << "|_______________________|\n";
    cout << "\nWelcome to PAOK BC Hangman.\n";
    cout << "\nThe words used in this game are surnames of PAOK basketball players.\n";
    cout << "You earn 10 points for each player you guess plus another\n20 points if you didn't make any incorrect guesses.\n";
    cout << "If you want to quit enter \";\" as your guess. Good Luck!\n\n";     
}

void constract_db(vector<string>* words){
     
     words->push_back("BERGINHS");
     words->push_back("XARITOPOYLOS");
     words->push_back("RINGSTROM");
     words->push_back("GILLESPIE");
     words->push_back("BASILEIOY");
     words->push_back("TSIAKOS");
     words->push_back("DIARRA");
     words->push_back("KUTLUAY");
     words->push_back("SFEIKOS");
     words->push_back("JORDAN");
     words->push_back("KOYBELAS");
     words->push_back("RHALIMI");
     words->push_back("GIANNOPOYLOS");
     words->push_back("GALAZOYLAS");
     words->push_back("DEMERTZHS");
     words->push_back("HORVATH");
     words->push_back("ROWE");
     words->push_back("SAUNDERS");
     words->push_back("HUMPHREY");
     words->push_back("HANSELL");
     
     words->push_back("ALLEN");
     words->push_back("MANWLOPOYLOS");
     words->push_back("SCEPANOVIC");
     words->push_back("SEKULIC");
     words->push_back("KALAMPOKHS");
     words->push_back("THOMAS");
     words->push_back("PANKO");
     words->push_back("PARKER");
     words->push_back("AGADAKOS");
     words->push_back("PASALIC");
     words->push_back("WASHINGTON");
     words->push_back("KOJADINOVIC");
     words->push_back("OSTOJIC");
     words->push_back("WATSON");
     
     words->push_back("KSANTHOPOYLOS");
     words->push_back("BASILEIADHS");
     words->push_back("GEWRGITSHS");
     words->push_back("ZUJOVIC");
     words->push_back("GKAGKALOYDHS");
     words->push_back("MAYROKEFALIDHS");
     words->push_back("MANCE");
     words->push_back("MURRAY");
     words->push_back("HENJAK");
     words->push_back("VUKSANOVIC");
     words->push_back("NDIAYE");
     words->push_back("SIMMONS");
     words->push_back("MAKSHANTSEV");
     words->push_back("TZINOPOYLOS");
     words->push_back("OSTOJIC");
     
     
     words->push_back("MULAOMEROVIC");
     words->push_back("KORWNIDHS");
     words->push_back("MAGLOS");
     words->push_back("BASILOPOYLOS");
     words->push_back("TAMIR");
     words->push_back("MAYE");
     words->push_back("NIELSEN");
     words->push_back("BASHMINOV");
     words->push_back("MPALOGIANNHS");
     words->push_back("GRGAT");
     
     words->push_back("PANTELIADHS");
     words->push_back("KAMARIWTHS");
     words->push_back("FIELDS");
     words->push_back("TEBETZIDHS");
     words->push_back("JURKOVIC");
     words->push_back("OKUNSKYY");
     words->push_back("RADOJEVIC");
     words->push_back("KARAMANOLEV");
     words->push_back("POWELL");  
     words->push_back("MARKOPOYLOS");
     words->push_back("PASALIDHS");
     
     words->push_back("MILISAVLJEVIC");
     words->push_back("APOSTOLIDHS");
     words->push_back("LHMNIATHS");
     words->push_back("XRHSTOY");
     words->push_back("KOMMATOS");  
     words->push_back("BATHHS");
     words->push_back("BRAGGS");
     words->push_back("MATERIC");
     words->push_back("CARTER");
     words->push_back("SCOTT");  
     words->push_back("PANAGIWTIDHS");
     words->push_back("KOPTHS");
     words->push_back("ALEXIS");
     
     words->push_back("COLDEBELLA");
     words->push_back("LIADELHS");  
     words->push_back("SIGALAS");
     words->push_back("WOOLRIDGE");
     words->push_back("CALLAHAN");
     words->push_back("MORALES");  
     words->push_back("NOLAN");
     words->push_back("EDWARDS");
     
     words->push_back("CARGOL");
     words->push_back("KORWNIOS");
     words->push_back("DAINEKO");  
     words->push_back("WEIS");
     words->push_back("RACCA");
     words->push_back("BLAIR");     
     words->push_back("GIANNOYLHS");
     words->push_back("TRIFTANIDHS");
     words->push_back("AVENT");  
     words->push_back("GKALHS");
     
     words->push_back("NIKOLAIDHS");
     words->push_back("BETOYLAS");          
     words->push_back("PRELEVIC");
     words->push_back("MASLARINOS");
     words->push_back("PERAL");  
     words->push_back("BAZAREVICH");
     words->push_back("ALEXANDER");          
     words->push_back("PAPAXRHSTOY");
     words->push_back("HLIOPOYLOS");          
     
     words->push_back("BERRY");
     words->push_back("KAKIOYSHS");
     words->push_back("KING");  
     words->push_back("DESPOS");
     
     words->push_back("MPOYNTOYRHS");
     words->push_back("STOJAKOVIC");               
     words->push_back("ROWAN");
     words->push_back("MCRAE");          
     words->push_back("ADDISON");
     words->push_back("PIERI");
     words->push_back("SHACKLEFORD");  
     
     words->push_back("SKILES");
     words->push_back("MAMATZIOLAS");
     words->push_back("BECK");               
     words->push_back("TSEKOS");
     words->push_back("BONNER");
     words->push_back("RENTZIAS");               
     words->push_back("DEBBS");
     
     words->push_back("FUNDERBURKE");
     words->push_back("GARRETT");               
     words->push_back("RUFFIN");
     
     words->push_back("KORFAS");               
     words->push_back("GALAKTEROS");
     words->push_back("SAVIC");
     words->push_back("MUSTAF");                    
     words->push_back("LAMBLEY");
     words->push_back("BULLARD");               
     
     words->push_back("BALABANITHHS");
     words->push_back("TAKIANOS");
     words->push_back("KOYKLAKHS");   
     words->push_back("KOTSOPOYLOS");
     
     words->push_back("LEVINGSTON");
     words->push_back("BARLOW");                                
     words->push_back("FILIPPOY");
     words->push_back("KATSIKHS");                    
     words->push_back("KOYKOYBITSKAS");
     
     words->push_back("PAPAXRONHS");                   
     words->push_back("MAKARAS");
     words->push_back("TSAKIRHS");                    
     words->push_back("PALIOYRAS");
     words->push_back("PARISOPOYLOS");
     words->push_back("MELETIADHS");               
     words->push_back("DHMAKOPOYLOS");
     words->push_back("KARAPOYRNOS");
     words->push_back("TSAFRAKIDHS");    
     
     words->push_back("IOANNOY");
     
     words->push_back("COOK");
     words->push_back("PAPASARANTOY");               
     words->push_back("MELHS");
     words->push_back("KARATZOYLIDHS");
     
     words->push_back("JONES");                                         
     
     words->push_back("BALABANIDHS");
     words->push_back("TAKIANOS");
     words->push_back("KOYKLAKHS"); 
     
     //  1976
     
     words->push_back("KANAKAKHS"); 
     
     //  1984
     
     words->push_back("ALEKSANDRHS");
     words->push_back("STAYROPOYLOS"); 
     words->push_back("KWNSTANTINIDHS");  
     words->push_back("MPAKOPOYLOS");
     words->push_back("KATSOYLHS");
     words->push_back("POLITHS");
     words->push_back("KOYMANTSIWTHS");
     words->push_back("MPOYRLIVAS"); 
     words->push_back("FASOYLAS");                        
     
     //  1959   
     words->push_back("AGGELIDHS");           
     words->push_back("ASTERIADHS");     
     words->push_back("DAPONTES");
     words->push_back("THEODWRIDHS");                    
     words->push_back("KOKKOS");
     words->push_back("KYRIAKOY");
     words->push_back("OIKONOMOY");                    
     words->push_back("KWNSTANTINIDHS");
     words->push_back("PASXALHS");
     words->push_back("STERGIOY");                    
     words->push_back("KLAGKAS");
     words->push_back("TAKIANOS");
     words->push_back("KOYKLAKHS");   
     
     //  updates (forgotten players)                 
     words->push_back("FORD");        
     words->push_back("MANOYSOS");   
}

void print_win(){
     cout << "Congratulations! You found all the players in the database.\n";
     cout << "You have a deep knowledge in PAOK's history and your patience is admirable.";
}    

void print_end(){
     cout << "If you have any suggestions that would improve the game,\nif you found a bug and you want to report it\nor if you just want to say hi\nyou can use the following e-mail:\n\npaokara_re@hotmail.com\n\n";
     cout << "Thanks for playing PAOK BC Hangman\n\n";
}    
